//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

extension API.ApiFoyer {

    /** Permet de modifier les abonnements quartiers utilisateur */
    public enum PostApiFoyerUpdateAbonnementsQuartiers {

        public static let service = APIService<Response>(id: "postApiFoyerUpdateAbonnementsQuartiers", tag: "Api Foyer", method: "POST", path: "/apiFoyer/updateAbonnementsQuartiers", hasBody: false)

        public final class Request: APIRequest<Response> {

            public struct Options {

                public var idsQuartier: String

                public var idFoyer: String

                public init(idsQuartier: String, idFoyer: String) {
                    self.idsQuartier = idsQuartier
                    self.idFoyer = idFoyer
                }
            }

            public var options: Options

            public init(options: Options) {
                self.options = options
                super.init(service: PostApiFoyerUpdateAbonnementsQuartiers.service)
            }

            /// convenience initialiser so an Option doesn't have to be created
            public convenience init(idsQuartier: String, idFoyer: String) {
                let options = Options(idsQuartier: idsQuartier, idFoyer: idFoyer)
                self.init(options: options)
            }

            public override var parameters: [String: Any] {
                var params: JSONDictionary = [:]
                params["idsQuartier"] = options.idsQuartier
                params["idFoyer"] = options.idFoyer
                return params
            }
        }

        public enum Response: APIResponseValue, CustomStringConvertible, CustomDebugStringConvertible {
            public typealias SuccessType = Void

            /** Succes */
            case status200

            /** Error */
            case status400

            /** Error */
            case status500

            public var success: Void? {
                switch self {
                case .status200: return ()
                default: return nil
                }
            }

            public var response: Any {
                switch self {
                default: return ()
                }
            }

            public var statusCode: Int {
                switch self {
                case .status200: return 200
                case .status400: return 400
                case .status500: return 500
                }
            }

            public var successful: Bool {
                switch self {
                case .status200: return true
                case .status400: return false
                case .status500: return false
                }
            }

            public init(statusCode: Int, data: Data) throws {
                switch statusCode {
                case 200: self = .status200
                case 400: self = .status400
                case 500: self = .status500
                default: throw APIError.unexpectedStatusCode(statusCode: statusCode, data: data)
                }
            }

            public var description: String {
                return "\(statusCode) \(successful ? "success" : "failure")"
            }

            public var debugDescription: String {
                var string = description
                let responseString = "\(response)"
                if responseString != "()" {
                    string += "\n\(responseString)"
                }
                return string
            }
        }
    }
}
